# ZFriday-13 for Zope

import re, time, os

import Globals
from OFS import SimpleItem
from Globals import DTMLFile

GET_BROWSER = re.compile('MSIE')

class fridayLocker(SimpleItem.SimpleItem):
    "Class of Friday 13"

    meta_type = 'Friday restrict'
    
    manage_options = (
        {'label': 'View', 'action': 'index_html'},
        {'label': 'Properties', 'action': 'manage_editForm',},
        )

    def __init__(self, id, dN, dNm):
        "Init of ZFriday"
        self.id = id
	
	self.dayName = str(dN)
	self.dayNum = str(dNm)
	
	if not self.dayName: self.dayName = 'Friday'
	if not self.dayNum:  self.dayNum  = '13'

    def imageBanner(self):
	"Return image banner"
	imagePath = os.path.join(Globals.package_home(globals()), 
				 'www/mozilla.png')
	imageFile = open(imagePath, 'r')
	imageBanner = imageFile.read()
	imageFile.close()
	self.REQUEST.RESPONSE.setHeader('content-type', 'image/png')
	
	return imageBanner


    def index_html(self, REQUEST):
	"Push output..."
	return str(self)


    Friday13 = DTMLFile('www/errMessage', globals())

	
    def __str__(self):
	localTime = time.strftime('%A,%d', time.localtime()).split(',')
	
	if self.dayName == '0': self.dayName = localTime[0]
	if self.dayNum  == '0': self.dayNum  = localTime[1]

	if localTime[0] == self.dayName and \
	   localTime[1] == self.dayNum  and \
	   GET_BROWSER.search(str(self.REQUEST['HTTP_USER_AGENT'])):
	    self.REQUEST.RESPONSE.redirect('%s/Friday13' % self.id)
	    return ''
	else:
	    # Still allowed IE?
	    if (localTime[0] != self.dayName or localTime[1] != self.dayNum)  and \
	       GET_BROWSER.search(str(self.REQUEST['HTTP_USER_AGENT'])):
		return '<a href="http://www.mozilla.org/releases/stable.html"><img src=%s/imageBanner border=0 alt="Download Mozilla"></a>' % self.id
	    else:
		# Yes, we return empty string to the browser.
		return ''
	    	
    
def manage_addZFriday(self, id, dayName, dayNum, RESPONSE=None):
    "Add a ZFriday to a folder."
    
    self._setObject(id, fridayLocker(id, dN = dayName, dNm = dayNum))
    RESPONSE.redirect('manage_workspace')


manage_addZFridayForm = DTMLFile('www/addZFriday', globals())
